
{$APPTYPE GUI}{$MODE DELPHI}

program demo37;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_SimplePlants_Ext1;

//const
 
//type
  
//var 

   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(tu,-tv, 0,-tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end;  


procedure MatCactus;
begin
  TextureSelectID(1);
end;

procedure MatSpike;
begin
  TextureSelectID(2);
end;

procedure MatCactus2;
begin
  TextureSelectID(3);
end;

procedure MatSpike2;
begin
  TextureSelectID(4);
end;

procedure MatCactus3;
begin
  TextureSelectID(5);
end;

procedure MatSpike3;
begin
  TextureSelectID(6);
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor04b.bmp',0);
  TextureLoadID('cactus.bmp',1);  
  TextureLoadID('spike.bmp',2);  
  TextureLoadID('cactus4.bmp',3);    
  TextureLoadID('spike1.bmp',4); 
  TextureLoadID('cactus3.bmp',5);    
  TextureLoadID('spike2.bmp',6);   
  
end;
begin 

  OpenGL_Texture();
  
  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(45,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, -6,10,0, 0.1); 

  TextureSelectID(0); 
  Quad(-15,0,-15, 15,0,-15, -15,0,15, 15,0,15, 4,4); 
  
  glPushMatrix;
  glTranslatef(-7,0,0);
  Cactus01AdvancedFractal3D(MatCactus,MatSpike,4,0,3, 5,12,3,2, 20, 7);
  glPopMatrix;
  
  glPushMatrix;
  glTranslatef(-3,0.35,0);
  glRotatef(40,0,0,-1); 
  Cactus01AdvancedFractal3D(MatCactus,MatSpike,2,0,3, 5,12,3,1.8, 20, 7);
  glPopMatrix;  
  
  
  glPushMatrix;
  glTranslatef(2,0,-10);
  Cactus01AdvancedFractal3D(MatCactus2,MatSpike2,3,5,3, 7,14,0.1,1.8, 20, 10);
  glPopMatrix;    
  
  
  glPushMatrix;
  glTranslatef(7,0,0);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,2.8,6.5,4.5, 4,12,6,1.5, 20, 4);
  glPopMatrix; 

  glPushMatrix;
  glTranslatef(9.7,0,3.5);
  glRotatef(40,0,1,0);   
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,2.8-0.4,6.5-0.4,4.5, 4,12,6,1.5, 20, 4);
  glPopMatrix;    
  
  glPushMatrix;
  glTranslatef(5.7,0,4.5);
  glRotatef(65,0,-1,0);   
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,2.8-0.5,6.5-1.2,4.5, 4,12,6,1.5, 20, 4);
  glPopMatrix;  
  
  
  glPushMatrix;
  glTranslatef(-3.5,0,6);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,1.3,6.5,2, 3,20,6,0.9, 20, 13);
  glPopMatrix; 

  glPushMatrix;
  glTranslatef(-1,0,6);
  glRotatef(10,0,0,-1);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,1.3,6.5,2, 3,20,6,0.9, 20, 13);
  glPopMatrix; 

  glPushMatrix;
  glTranslatef(-6,0,7);
  glRotatef(10,0,0,1);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,1.3,6.5,2, 3,20,6,0.9, 20, 13);
  glPopMatrix;  
  
  glPushMatrix;
  glTranslatef(-2,0,8);
  glRotatef(15,1,0,0);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,1.3,6.5,2, 3,20,6,0.9, 20, 13);
  glPopMatrix;  
  
  glPushMatrix;
  glTranslatef(-4.35,0,8.15);
  glRotatef(15,1,0,0);
  Cactus01AdvancedFractal3D(MatCactus3,MatSpike3,0.9,6.5,2, 3,20,6,0.9, 20, 13);
  glPopMatrix;   
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio generazione di Cactus', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
